import { PivotGridType } from '../grids/common/grid.interface';
import { IPivotDimension, IPivotDimensionStrategy, IPivotKeys, IPivotValue } from '../grids/pivot-grid/pivot-grid.interface';
import { FilteringStrategy } from './filtering-strategy';
import { DefaultSortingStrategy, SortingDirection } from './sorting-strategy';
export declare class NoopPivotDimensionsStrategy implements IPivotDimensionStrategy {
    private static _instance;
    static instance(): NoopPivotDimensionsStrategy;
    process(collection: any[], _: IPivotDimension[], __: IPivotValue[]): any[];
}
export declare class PivotRowDimensionsStrategy implements IPivotDimensionStrategy {
    private static _instance;
    static instance(): PivotRowDimensionsStrategy;
    process(collection: any, rows: IPivotDimension[], values?: IPivotValue[], pivotKeys?: IPivotKeys): any[];
}
export declare class PivotColumnDimensionsStrategy implements IPivotDimensionStrategy {
    private static _instance;
    static instance(): PivotRowDimensionsStrategy | PivotColumnDimensionsStrategy;
    process(collection: any[], columns: IPivotDimension[], values: IPivotValue[], pivotKeys?: IPivotKeys): any[];
    private processHierarchy;
    private groupColumns;
    private getLeafs;
    private isLeaf;
}
export declare class DimensionValuesFilteringStrategy extends FilteringStrategy {
    private fields?;
    /**
     * Creates a new instance of FormattedValuesFilteringStrategy.
     *
     * @param fields An array of column field names that should be formatted.
     * If omitted the values of all columns which has formatter will be formatted.
     */
    constructor(fields?: string[]);
    protected getFieldValue(rec: any, fieldName: string, isDate?: boolean, isTime?: boolean, grid?: PivotGridType): any;
}
export declare class DefaultPivotSortingStrategy extends DefaultSortingStrategy {
    protected static _instance: DefaultPivotSortingStrategy;
    protected dimension: any;
    static instance(): DefaultPivotSortingStrategy;
    sort(data: any[], fieldName: string, dir: SortingDirection, ignoreCase: boolean, valueResolver: (obj: any, key: string, isDate?: boolean) => any, isDate?: boolean, isTime?: boolean, grid?: PivotGridType): any[];
    protected getFieldValue(obj: any, key: string, isDate?: boolean, isTime?: boolean): any;
}
