import { PipeTransform } from '@angular/core';
import { IFilteringExpressionsTree } from '../../data-operations/filtering-expressions-tree';
import { IFilteringStrategy } from '../../data-operations/filtering-strategy';
import { IPivotConfiguration, IPivotKeys } from './pivot-grid.interface';
import { ISortingExpression } from '../../data-operations/sorting-strategy';
import { GridType } from '../common/grid.interface';
import { GridBaseAPIService } from '../api.service';
import { IgxGridBaseDirective } from '../grid-base.directive';
import { IGridSortingStrategy } from '../common/strategy';
import * as i0 from "@angular/core";
/**
 * @hidden
 */
export declare class IgxPivotRowPipe implements PipeTransform {
    constructor();
    transform(collection: any, config: IPivotConfiguration, _: Map<any, boolean>, _pipeTrigger?: number, __?: any): any[];
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxPivotRowPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<IgxPivotRowPipe, "pivotGridRow">;
}
/**
 * @hidden
 */
export declare class IgxPivotRowExpansionPipe implements PipeTransform {
    constructor();
    transform(collection: any[], config: IPivotConfiguration, expansionStates: Map<any, boolean>, defaultExpand: boolean, _pipeTrigger?: number, __?: any): any[];
    private cleanState;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxPivotRowExpansionPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<IgxPivotRowExpansionPipe, "pivotGridRowExpansion">;
}
/**
 * @hidden
 */
export declare class IgxPivotColumnPipe implements PipeTransform {
    transform(collection: any, config: IPivotConfiguration, _: Map<any, boolean>, _pipeTrigger?: number, __?: any): any[];
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxPivotColumnPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<IgxPivotColumnPipe, "pivotGridColumn">;
}
/**
 * @hidden
 */
export declare class IgxPivotGridFilterPipe implements PipeTransform {
    private gridAPI;
    constructor(gridAPI: GridBaseAPIService<IgxGridBaseDirective & GridType>);
    transform(collection: any[], config: IPivotConfiguration, filterStrategy: IFilteringStrategy, advancedExpressionsTree: IFilteringExpressionsTree, _filterPipeTrigger: number, _pipeTrigger: number): any[];
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxPivotGridFilterPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<IgxPivotGridFilterPipe, "pivotGridFilter">;
}
/**
 * @hidden
 */
export declare class IgxPivotGridColumnSortingPipe implements PipeTransform {
    transform(collection: any[], expressions: ISortingExpression[], sorting: IGridSortingStrategy, pipeTrigger: number, pivotKeys?: IPivotKeys): any[];
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxPivotGridColumnSortingPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<IgxPivotGridColumnSortingPipe, "pivotGridColumnSort">;
}
/**
 * @hidden
 */
export declare class IgxPivotGridSortingPipe implements PipeTransform {
    private gridAPI;
    constructor(gridAPI: GridBaseAPIService<IgxGridBaseDirective & GridType>);
    transform(collection: any[], config: IPivotConfiguration, sorting: IGridSortingStrategy, id: string, pipeTrigger: number, pinned?: any): any[];
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxPivotGridSortingPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<IgxPivotGridSortingPipe, "pivotGridSort">;
}
