import { ChangeDetectorRef, ElementRef, Renderer2 } from '@angular/core';
import { IBaseChipEventArgs, IgxChipComponent } from '../../chips/chip.component';
import { ISelectionEventArgs } from '../../drop-down/drop-down.common';
import { IgxDropDownComponent } from '../../drop-down/drop-down.component';
import { PivotGridType } from '../common/grid.interface';
import { IgxGridHeaderRowComponent } from '../headers/grid-header-row.component';
import { IPivotAggregator, IPivotDimension, IPivotValue, PivotDimensionType } from './pivot-grid.interface';
import * as i0 from "@angular/core";
/**
 *
 * For all intents & purposes treat this component as what a <thead> usually is in the default <table> element.
 *
 * This container holds the pivot grid header elements and their behavior/interactions.
 *
 * @hidden @internal
 */
export declare class IgxPivotHeaderRowComponent extends IgxGridHeaderRowComponent {
    grid: PivotGridType;
    protected ref: ElementRef<HTMLElement>;
    protected cdr: ChangeDetectorRef;
    protected renderer: Renderer2;
    aggregateList: IPivotAggregator[];
    value: IPivotValue;
    private _dropPos;
    private _dropLeftIndicatorClass;
    private _dropRightIndicatorClass;
    private valueData;
    private _subMenuPositionSettings;
    private _subMenuOverlaySettings;
    constructor(grid: PivotGridType, ref: ElementRef<HTMLElement>, cdr: ChangeDetectorRef, renderer: Renderer2);
    getAggregateList(val: IPivotValue): IPivotAggregator[];
    rowRemoved(event: IBaseChipEventArgs): void;
    columnRemoved(event: IBaseChipEventArgs): void;
    valueRemoved(event: IBaseChipEventArgs): void;
    filterRemoved(event: IBaseChipEventArgs): void;
    onFilteringIconPointerDown(event: any): void;
    onFilteringIconClick(event: any, dimension: any): void;
    onSummaryClick(eventArgs: any, value: IPivotValue, dropdown: IgxDropDownComponent, chip: IgxChipComponent): void;
    onAggregationChange(event: ISelectionEventArgs): void;
    isSelected(val: IPivotAggregator): boolean;
    onChipSort(event: any, dimension: IPivotDimension, dimensionType: PivotDimensionType): void;
    onDimDragOver(event: any, dimension?: PivotDimensionType): void;
    onDimDragLeave(event: any): void;
    onAreaDragEnter(event: any, area: any, dimension?: PivotDimensionType): void;
    onAreaDragLeave(event: any, area: any): void;
    onValueDrop(event: any, area: any): void;
    onDimDrop(event: any, area: any, dimension: PivotDimensionType): void;
    protected getDimensionsByType(dimension: PivotDimensionType): IPivotDimension[];
    protected getAggregatorsForValue(value: IPivotValue): IPivotAggregator[];
    protected updateDropDown(value: IPivotValue, dropdown: IgxDropDownComponent, chip: IgxChipComponent): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxPivotHeaderRowComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxPivotHeaderRowComponent, "igx-pivot-header-row", never, {}, {}, never, never>;
}
