import { ChangeDetectorRef, ElementRef } from '@angular/core';
import { PlatformUtil } from '../../core/utils';
import { PivotGridType } from '../common/grid.interface';
import { IgxFilteringService } from '../filtering/grid-filtering.service';
import { IgxGridHeaderGroupComponent } from '../headers/grid-header-group.component';
import { IgxColumnResizingService } from '../resizing/resizing.service';
import { IgxRowDirective } from '../row.directive';
import * as i0 from "@angular/core";
/**
 * @hidden
 */
export declare class IgxPivotRowDimensionHeaderGroupComponent extends IgxGridHeaderGroupComponent {
    private cdRef;
    grid: PivotGridType;
    private elementRef;
    colResizingService: IgxColumnResizingService;
    filteringService: IgxFilteringService;
    protected platform: PlatformUtil;
    constructor(cdRef: ChangeDetectorRef, grid: PivotGridType, elementRef: ElementRef<HTMLElement>, colResizingService: IgxColumnResizingService, filteringService: IgxFilteringService, platform: PlatformUtil);
    /**
     * @hidden
     * @internal
     */
    intRow: IgxRowDirective;
    get headerID(): string;
    /**
     * @hidden
     * @internal
     */
    get visibleIndex(): number;
    get active(): boolean;
    get activeGroup(): boolean;
    protected get activeNode(): {
        row: number;
        column: number;
        level: any;
        mchCache: any;
        layout: any;
    };
    private findRootDimension;
    activate(): void;
    /**
     * @hidden @internal
     */
    pointerdown(_event: PointerEvent): void;
    /**
     * @hidden @internal
     */
    onMouseDown(_event: MouseEvent): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxPivotRowDimensionHeaderGroupComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxPivotRowDimensionHeaderGroupComponent, "igx-pivot-row-dimension-header-group", never, { "intRow": "intRow"; }, {}, never, never>;
}
