import { ChangeDetectorRef, ComponentFactoryResolver, ElementRef, OnChanges, SimpleChanges, TemplateRef, ViewContainerRef } from '@angular/core';
import { IgxRowDirective } from '../row.directive';
import { IgxGridSelectionService } from '../selection/selection.service';
import { IPivotDimension, IPivotDimensionData } from './pivot-grid.interface';
import { IgxColumnComponent } from '../columns/column.component';
import { PivotGridType } from '../common/grid.interface';
import * as i0 from "@angular/core";
export declare class IgxPivotRowComponent extends IgxRowDirective implements OnChanges {
    grid: PivotGridType;
    selectionService: IgxGridSelectionService;
    element: ElementRef<HTMLElement>;
    cdr: ChangeDetectorRef;
    protected resolver: ComponentFactoryResolver;
    protected viewRef: ViewContainerRef;
    pivotRowWidths: number;
    /**
     * @hidden @internal
     */
    headerTemplate: TemplateRef<any>;
    /**
     * @hidden @internal
     */
    headerTemplateDefault: TemplateRef<any>;
    rowDimensionData: IPivotDimensionData[];
    get rowDimension(): import("../common/grid.interface").ColumnType[];
    /**
     * @hidden
     */
    get selected(): boolean;
    constructor(grid: PivotGridType, selectionService: IgxGridSelectionService, element: ElementRef<HTMLElement>, cdr: ChangeDetectorRef, resolver: ComponentFactoryResolver, viewRef: ViewContainerRef);
    /**
     * @hidden
     * @internal
     */
    get viewIndex(): number;
    /**
     * @hidden
     * @internal
     */
    getRowDimensionKey(col: IgxColumnComponent): string;
    getExpandState(col: IgxColumnComponent): boolean;
    getLevel(col: IgxColumnComponent): any;
    /**
     * @hidden
     * @internal
     */
    ngOnChanges(changes: SimpleChanges): void;
    getCellClass(col: IgxColumnComponent): any;
    isCellActive(visibleColumnIndex: any): boolean;
    /**
     * @hidden @internal
     */
    selectPivotRow(col: any, event?: any): void;
    protected extractFromDimensions(rowDimConfig: IPivotDimension[], level: number): void;
    protected extractFromDimension(dim: IPivotDimension, index: number, lvl: number, rootDim: IPivotDimension): IgxColumnComponent;
    protected _createColComponent(field: string, header: string, index: number, dim: IPivotDimension, lvl: number, rootDim: IPivotDimension): IgxColumnComponent;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxPivotRowComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxPivotRowComponent, "igx-pivot-row", never, { "pivotRowWidths": "pivotRowWidths"; "selected": "selected"; }, {}, never, never>;
}
