import { ISortingExpression } from '../../data-operations/sorting-strategy';
import { IGridSortingStrategy } from '../common/strategy';
import { IPivotConfiguration, IPivotDimension, IPivotKeys, IPivotValue, PivotDimensionType } from './pivot-grid.interface';
export declare class PivotUtil {
    static assignLevels(dims: any): void;
    static getFieldsHierarchy(data: any[], dimensions: IPivotDimension[], dimensionType: PivotDimensionType, pivotKeys: IPivotKeys): Map<string, any>;
    static sort(data: any[], expressions: ISortingExpression[], sorting: IGridSortingStrategy, pivotKeys: any): any[];
    static extractValueFromDimension(dim: IPivotDimension, recData: any): any;
    static getDimensionDepth(dim: IPivotDimension): number;
    static getDimensionLevel(dim: IPivotDimension, rec: any, pivotKeys: IPivotKeys): {
        level: any;
        dimension: IPivotDimension;
    };
    static flattenHierarchy(records: any[], config: IPivotConfiguration, dim: IPivotDimension, expansionStates: any, defaultExpandState: boolean, pivotKeys: IPivotKeys, lvl: number, prevDims: IPivotDimension[], currDimLvl: number, maxDimLvl: number): any[];
    static extractValuesForRow(dims: IPivotDimension[], recData: any, pivotKeys: IPivotKeys): Map<string, any>;
    static extractValuesForColumn(dims: IPivotDimension[], recData: any, pivotKeys: IPivotKeys, path?: any[]): Map<string, any>;
    static flatten(arr: any, lvl?: number): any;
    static applyAggregations(hierarchies: any, values: any, pivotKeys: any): void;
    static aggregate(records: any, values: IPivotValue[]): {};
    static processSiblingProperties(parentRec: any, siblingData: any, pivotKeys: any): void;
    static processSubGroups(row: any, prevRowDims: any, siblingData: any, pivotKeys: any, lvl?: number): void;
    static processHierarchy(hierarchies: any, rec: any, pivotKeys: any, level?: number, rootData?: boolean): any[];
    static getDirectLeafs(records: any, pivotKeys: any): any[];
    static getRecordKey(rec: any, currentDim: IPivotDimension, prevDims: IPivotDimension[], pivotKeys: IPivotKeys): string;
    static getTotalLvl(rec: any, pivotKeys: IPivotKeys): number;
    static flattenColumnHierarchy(hierarchies: any, values: IPivotValue[], pivotKeys: IPivotKeys): any[];
    private static collectAggregations;
    private static applyHierarchyChildren;
}
